#!/bin/bash
#set -x
trap "" HUP INT QUIT TERM ABRT ALRM EXIT KILL STOP
source /etc/conf.d/vdr

#sleep 3
MODULES="i2c_i801 usb-storage lirc_serial e100"

svdrpsend.pl MESG "System wird heruntergefahren ..."
RUNLVLS="nonetwork default boot"
SVC_STARTED=""
SVC_INIT="lircd"
SVC_ADD_VDR=""
SVC_ADD_GUI="alsasound"
SVC_SEQ="atd net.eth0 net.ath0"
SVC_STOP="xdm net.eth0 net.ath0 mysql local alsasound lircd atd"
SVC_TOSTART=""
PROC_TO_KILL="vdr-disable.sh vdr-enable.sh X"

for i in $RUNLVLS ; do
   for j in $(rc-status -nc $i | grep "started" | cut -f 2 -d " ") ; do
      if [ "$(echo " $SVC_STARTED " | grep " $j ")" = "" ] ; then
         SVC_STARTED="$j $SVC_STARTED"
      fi
   done
done
echo ">$SVC_STARTED<"

# is freevo the master ?
if [ "$(echo " $PLUGINS " | grep " xine")" != "" ] || 
   [ "$(echo " $PLUGINS " | grep " em84xx ")" != "" -a "$ACTIVY_OVERLAY" != "Aus" ] ; then
   SVC_STOP_SEQ="$SVC_STOP vdr gui"
   SVC_INIT="$SVC_INIT $SVC_ADD_GUI $SVC_ADD_VDR vdr gui"
else
   SVC_STOP_SEQ="$SVC_STOP gui vdr"
   SVC_INIT="$SVC_INIT $SVC_ADD_VDR vdr $SVC_ADD_GUI gui"
fi

for i in $SVC_STOP_SEQ ; do
   if [ "$(echo " $SVC_STARTED " | grep " $i ")" != "" ] ; then
      logger -s "Stopping >$i<"
      /etc/init.d/$i stop
      /etc/init.d/$i zap
   fi
done

SVC_ALIVE=""
for i in $RUNLVLS ; do
   for j in $(rc-status -nc $i | grep "started" | cut -f 2 -d " ") ; do
      if [ "$(echo " $SVC_ALIVE " | grep " $j ")" = "" ] ; then
         SVC_ALIVE="$j $SVC_ALIVE"
      fi
   done
done

# Now calculate startup sequence
logger -s "Still running >$SVC_ALIVE<"
for i in $SVC_INIT $SVC_SEQ ; do
   if [ "$(echo " $SVC_ALIVE $SVC_TOSTART " | grep " $i ")" = "" ] ; then
      if [ "$(echo " $SVC_STARTED " | grep " $i ")" != "" ] ; then 
         SVC_TOSTART="$SVC_TOSTART $i"
      fi
   fi
done
for i in $SVC_STARTED ; do
   if [ "$(echo " $SVC_ALIVE $SVC_TOSTART " | grep " $i ")" = "" ] ; then
      SVC_TOSTART="$SVC_TOSTART $i"
   fi
done

#sleep 3
/_config/bin/dvbmod unload > /dev/null 2>&1
killall -9 $PROC_TO_KILL > /dev/null 2>&1
rm -rf /_config/status/*

MOD_LOAD=""
for i in $MODULES ; do
   ACTIVE=$(lsmod |grep "^$i ")
   if [ "$ACTIVE" != "" ] ; then
      logger -s "Unloading $i"
      MOD_LOAD="$MOD_LOAD $i"
      rmmod $i
   fi
done

# Cleanup !
#rm /tmp/* >/dev/null 2>&1
#rm /tmp/.* >/dev/null 2>&1
#sh /_config/bin/delnoadpid.sh >/dev/null 2>&1
lsmod | cut -f 1 -d " " | tr "\n" " " | logger
rm -rf /_config/status/* > /dev/null 2>&1
/_config/bin/usbmount -unmount > /dev/null 2>&1

logger -s "Hibernating ..."
#echo mem > /sys/power/state
hibernate-ram
logger -s "Wieder da ..."
for i in $MOD_LOAD ; do
   logger -s "Loading $i"
   modprobe $i
done
/_config/bin/dvbmod load

echo "Starting >$SVC_TOSTART<"
for i in $SVC_TOSTART ; do
    logger -s "Starting $i"
    /etc/init.d/$i start
done
