#! /bin/bash
#
#set -x
MOUNT_POINT="/media"

usb_mount() {
   if [ ! -e $MOUNT_POINT ] ; then
      mkdir -p $MOUNT_POINT
   fi
   if [ "$1" = "" ] ; then
      for i in $(seq 1 9) ; do
         USB_DEV=$(ls /dev/sd?? /dev/sg?? 2>/dev/null)
         if [ "$USB_DEV" = "" ] ; then
            sleep 1
         else
            break
         fi	 
      done      
   else
      USB_DEV=$1
   fi      
   USB_MOUNTS=$(mount | grep "^/dev" | grep "on ${MOUNT_POINT}/usbdisk" | cut -f 3 -d " ")
   logger -s "USB: <${USB_DEV}-${USB_MOUNTS}>"
   for i in $USB_DEV ; do
      MOUNTED="$(mount | grep "^${i}" | cut -f 3 -d " ")"
      if [ "$MOUNTED" = "" ] ; then
         for j in $(seq 1 9) ; do
            if [ ! -e ${MOUNT_POINT}/usbdisk${j} ] ; then
               mkdir ${MOUNT_POINT}/usbdisk${j} > /dev/null 2>&1
               mount $i ${MOUNT_POINT}/usbdisk${j}
               if [ "$?" = "0" ] ; then
                  logger -s "$i mounted on ${MOUNT_POINT}/usbdisk${j}"
		  screen -dm sh -c "sh /_config/bin/linkvid.sh ${MOUNT_POINT}/usbdisk${j}"
               else
                  rmdir ${MOUNT_POINT}/usbdisk${j} > /dev/null 2>&1
                  logger -s "Error $? <mount $i ${MOUNT_POINT}/usbdisk${j}>"
               fi   
               break
            fi   
         done
      else
         logger -s "$i is already mounted"
	 screen -dm sh -c "sh /_config/bin/linkvid.sh ${MOUNTED}"
      fi
   done
}

usb_unmount() {
   if [ "$1" = "" ] ; then
      USB_MOUNTS=$(mount | grep "^/dev" | grep "on ${MOUNT_POINT}/usbdisk" | cut -f 3 -d " ")
   else
      USB_MOUNTS=$(mount | grep "^$1" | grep "on ${MOUNT_POINT}/usbdisk" | cut -f 3 -d " ")   
      /_config/bin/linkvid.sh ${i} -del
   fi      
#   echo "<$USB_MOUNTS>"
   for i in $USB_MOUNTS ; do
      umount ${i} > /dev/null 2>&1
      logger -s "${i} unmounted"
      rmdir ${i} > /dev/null 2>&1
      /_config/bin/linkvid.sh ${i} -del
   done
   rmdir $MOUNT_POINT/usbdisk* > /dev/null 2>&1
}

#set -x
logger "$0 -$1-$2-$3"
if [ "$1" = "-mount" ] ; then
   [ "$2" = "" ] && usb_unmount
   usb_mount $2
elif [ "$1" = "-unmount" ] ; then
   usb_unmount $2
elif [ "$1" = "-remount" ] ; then
   unmount_all
   rmmod usb-storage
   modprobe usb-storage
   echo "$0 -mount"  
   screen -dm sh -c "sleep 60 | $0 -mount"
else
   logger -s "usbmount unknown parameter <$1>"
   echo "Syntax: $0 [-mount|-unmount|-remount] [device]"
fi

